﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MainNameSpace
{
    /// <summary>
    /// This is the main class
    /// </summary>
    class Program
    {
        /// <summary>
        /// This is the main method
        ///  please try to use a link to <see cref="PublicClass.publicStaticMethod(string[])"/>
        ///  <seealso cref="PublicClass.publicStaticMethod(string[]))"/>
        /// </summary>
        /// <param name="args"></param>
        internal static void Main(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
        public string StringProperty { get; private set; }
    }

    /// <summary>
    ///  this is an internal class. <see cref="PublicClass.publicMethod2(string[])"/> 
    ///  <seealso cref="PublicClass.publicMethod2(string[])">link to Public method</seealso>
    /// </summary>
    internal class InternalClass
    {
        /// <summary>
        /// this is a public method
        /// </summary>
        /// <param name="args"></param>
        public static void publicMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
        /// <summary>
        /// this is an internal method
        /// </summary>
        /// <param name="args"></param>
        internal static void InternalMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
    }

    /// <summary>
    ///  this is a public class
    /// </summary>
    public class PublicClass
    {
        /// <summary>
        /// this is a public method
        /// </summary>
        /// <param name="args"></param>
        public void publicMethod2(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
        /// <summary>
        /// this is an internal method
        /// </summary>
        /// <param name="args"></param>
        internal void InternalMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }

        /// <summary>
        /// this is a public static method
        /// </summary>
        /// <param name="args"></param>
        public static void publicStaticMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }

        /// <summary>
        /// this is an internal static method
        /// </summary>
        /// <param name="args"></param>
        internal static void InternalStaticMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
    }

    /// <summary>
    ///  this is a public static class
    /// </summary>
    public static class PublicStaticClass
    {
        /// <summary>
        /// this is a public method
        /// </summary>
        /// <param name="args"></param>
        public static void publicMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
        /// <summary>
        /// this is an internal method
        /// </summary>
        /// <param name="args"></param>
        internal static void InternalMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
    }

    /// <summary>
    ///  this is an internal static class
    /// </summary>
    internal static class InternalStaticClass
    {
        /// <summary>
        /// this is a public method
        /// </summary>
        /// <param name="args"></param>
        public static void publicMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
        /// <summary>
        /// this is an internal method
        /// </summary>
        /// <param name="args"></param>
        internal static void InternalMethod(string[] args)
        {
            Console.WriteLine("Hello Doxygen reader!");
        }
    }
}
